#define ERR_INTERNAL                                       0
#define ERR_MAX_LEX_DEPTH                                  1
#define ERR_OUT_OF_MEMORY                                  2
#define ERR_LEX_UNEXPECTED_CHAR                            3
#define ERR_OTHER_ERROR                                    4
#define ERR_ILLEGAL_KEYWORD                                5
#define ERR_ID_ENDS_IN_HYPHEN                              6
#define ERR_LEADING_ZEROS                                  7
#define ERR_NUMBER_TOO_LARGE                               8
#define ERR_MODULENAME_64                                  9
#define ERR_MODULENAME_32                                  10
#define ERR_TYPENAME_64                                    11
#define ERR_TYPENAME_32                                    12
#define ERR_OIDNAME_64                                     13
#define ERR_OIDNAME_32                                     14
#define ERR_ENUMNAME_64                                    15
#define ERR_ENUMNAME_32                                    16
#define ERR_BITNAME_64                                     17
#define ERR_BITNAME_32                                     18
#define ERR_UCIDENTIFIER_64                                19
#define ERR_LCIDENTIFIER_64                                20
#define ERR_TRAP_TYPE                                      21
#define ERR_TOO_MANY_MODULE_IDENTITIES                     22
#define ERR_NO_MODULE_IDENTITY                             23
#define ERR_OID_DEFVAL_TOO_LONG_SMIV2                      24
#define ERR_OID_DEFVAL_TOO_LONG_SMIV1                      25
#define ERR_INVALID_SMIV1_ACCESS                           26
#define ERR_INVALID_SMIV2_ACCESS                           27
#define ERR_SMIV2_WRITE_ONLY                               28
#define ERR_SMIV1_WRITE_ONLY                               29
#define ERR_INVALID_NOTIFICATION_VARIATION_ACCESS          30
#define ERR_INVALID_VARIATION_ACCESS                       31
#define ERR_NOTIFICATION_VARIATION_SYNTAX                  32
#define ERR_NOTIFICATION_VARIATION_WRITESYNTAX             33
#define ERR_DEFVAL_SYNTAX                                  34
#define ERR_NOTIFICATION_VARIATION_DEFVAL                  35
#define ERR_NOTIFICATION_VARIATION_CREATION                36
#define ERR_MODULE_IDENTITY_NOT_FIRST                      37
#define ERR_INVALID_SMIV1_STATUS                           38
#define ERR_INVALID_SMIV2_STATUS                           39
#define ERR_INVALID_CAPABILITIES_STATUS                    40
#define ERR_OIDNAME_INCLUDES_HYPHEN                        41
#define ERR_ILLEGAL_CHAR_IN_STRING                         42
#define ERR_BIN_STRING_MUL8                                43
#define ERR_HEX_STRING_MUL2                                44
#define ERR_FLUSH_DECLARATION                              45
#define ERR_MAX_ACCESS_IN_SMIV1                            46
#define ERR_ACCESS_IN_SMIV2                                47
#define ERR_MODULE_NOT_FOUND                               48
#define ERR_OPENING_INPUTFILE                              49
#define ERR_ILLEGAL_INPUTFILE                              50
#define ERR_UNKNOWN_OIDLABEL                               51
#define ERR_OIDLABEL_CHANGED                               52
#define ERR_IDENTIFIER_OID_CHANGED                         53
#define ERR_EXISTENT_OBJECT                                54
#define ERR_IDENTIFIER_NOT_IN_MODULE                       55
#define ERR_MACRO                                          56
#define ERR_CHOICE                                         57
#define ERR_TYPE_SMI_OR_SPPI                               58
#define ERR_TYPE_SPPI                                      59
#define ERR_TYPE_TAG                                       60
#define ERR_EXPORTS                                        61
#define ERR_ILLEGALLY_QUALIFIED                            62
#define ERR_MISSING_DESCRIPTION                            63
#define ERR_OIDLABEL_NOT_FIRST                             64
#define ERR_UNKNOWN_TYPE                                   65
#define ERR_UNKNOWN_CLASS                                  66
#define ERR_UNKNOWN_TYPE_OR_CLASS                          67
#define ERR_ATTRIBUTE_CLASS_ACCESS                         68
#define ERR_ATTRIBUTE_MISSING_ACCESS                       69
#define ERR_ATTRIBUTE_CLASS_DEFAULT                        70
#define ERR_ATTRIBUTE_CLASS_FORMAT                         71
#define ERR_ATTRIBUTE_CLASS_UNITS                          72
#define ERR_DUPLICATE_TYPE_NAME                            73
#define ERR_ATTRIBUTE_NOT_FOUND                            74
#define ERR_DUPLICATE_ATTRIBUTE_NAME                       75
#define ERR_DUPLICATE_CLASS_NAME                           76
#define ERR_ILLEGAL_RANGE_FOR_COUNTER                      77
#define ERR_ILLEGAL_RANGE_FOR_PARENT_TYPE                  78
#define ERR_ILLEGAL_SIZE_FOR_PARENT_TYPE                   79
#define ERR_ILLEGAL_ENUM_FOR_PARENT_TYPE                   80
#define ERR_SMIV2_SIGNED_NUMBER_RANGE                      81
#define ERR_SMIV2_UNSIGNED_NUMBER_RANGE                    82
#define ERR_INTEGER32_TOO_LARGE                            83
#define ERR_UNEXPECTED_VALUETYPE                           84
#define ERR_FLOAT_OVERFLOW                                 85
#define ERR_SMI_NOT_SUPPORTED                              86
#define ERR_SMING_NOT_SUPPORTED                            87
#define ERR_UNUSED_IMPORT                                  88
#define ERR_MACRO_NOT_IMPORTED                             89
#define ERR_IMPLICIT_NODE                                  90
#define ERR_SCALAR_READCREATE                              91
#define ERR_NAMEDNUMBER_INCLUDES_HYPHEN                    92
#define ERR_NAMEDBIT_INCLUDES_HYPHEN                       93
#define ERR_REDEFINITION                                   94
#define ERR_EXT_REDEFINITION                               95
#define ERR_CASE_REDEFINITION                              96
#define ERR_EXT_CASE_REDEFINITION                          97
#define ERR_BASETYPE_REDEFINITION                          98
#define ERR_PREVIOUS_DEFINITION                            99
#define ERR_INVALID_FORMAT                                 100
#define ERR_REFINEMENT_ALREADY_EXISTS                      101
#define ERR_OPTIONALGROUP_ALREADY_EXISTS                   102
#define ERR_UNEXPECTED_TYPE_RESTRICTION                    103
#define ERR_UNKNOWN_CONFIG_CMD                             104
#define ERR_CACHE_CONFIG_NOT_SUPPORTED                     105
#define ERR_SMIV2_OPAQUE_OBSOLETE                          106
#define ERR_SPPI_OPAQUE_OBSOLETE                           107
#define ERR_DATE_CHARACTER                                 108
#define ERR_DATE_LENGTH                                    109
#define ERR_DATE_VALUE                                     110
#define ERR_DATE_YEAR_2DIGITS                              111
#define ERR_DATE_YEAR                                      112
#define ERR_DATE_MONTH                                     113
#define ERR_DATE_DAY                                       114
#define ERR_DATE_HOUR                                      115
#define ERR_DATE_MINUTES                                   116
#define ERR_DATE_IN_FUTURE                                 117
#define ERR_DATE_IN_PAST                                   118
#define ERR_REVISION_NOT_DESCENDING                        119
#define ERR_REVISION_MISSING                               120
#define ERR_REVISION_AFTER_LAST_UPDATE                     121
#define ERR_INTEGER_IN_SMIV2                               122
#define ERR_MODULE_ALREADY_LOADED                          123
#define ERR_IDENTITY_PARENT_NOT_FOUND                      124
#define ERR_SMIV2_BASETYPE_NOT_IMPORTED                    125
#define ERR_BASETYPE_UNKNOWN                               126
#define ERR_ROW_SUBID_ONE                                  127
#define ERR_ROWNAME_ENTRY                                  128
#define ERR_TABLENAME_TABLE                                129
#define ERR_ROWNAME_TABLENAME                              130
#define ERR_SMIV2_TYPE_ASSIGNEMENT                         131
#define ERR_ILLEGAL_IMPORT                                 132
#define ERR_SMIV2_NESTED_TEXTUAL_CONVENTION                133
#define ERR_TABLE_ACCESS                                   134
#define ERR_ROW_ACCESS                                     135
#define ERR_COUNTER_ACCESS                                 136
#define ERR_ENUM_SUBTYPE_OF                                137
#define ERR_BITS_SUBTYPE_OF                                138
#define ERR_ENUM_SUBTYPE                                   139
#define ERR_BITS_SUBTYPE                                   140
#define ERR_ENUM_NAME_REDEFINITION                         141
#define ERR_ENUM_NUMBER_REDEFINITION                       142
#define ERR_ENUM_NAME_NOT_DEFINED                          143
#define ERR_ENUM_ZERO                                      144
#define ERR_BITS_NAME_REDEFINITION                         145
#define ERR_BITS_NUMBER_REDEFINITION                       146
#define ERR_BITS_NUMBER_NEGATIVE                           147
#define ERR_BITS_NUMBER_TOO_LARGE                          148
#define ERR_BITS_NUMBER_LARGE                              149
#define ERR_BITS_ZERO_NOT_NAMED                            150
#define ERR_RANGE_OUT_OF_BASETYPE                          151
#define ERR_RANGE_OVERLAP                                  152
#define ERR_RANGES_NOT_ASCENDING                           153
#define ERR_NAMED_NUMBERS_NOT_ASCENDING                    154
#define ERR_EXCHANGED_RANGE_LIMITS                         155
#define ERR_INDEX_BASETYPE                                 156
#define ERR_INDEX_TOO_LARGE                                157
#define ERR_INDEX_NO_RANGE                                 158
#define ERR_INDEX_NO_RANGE_MOD                             159
#define ERR_INDEX_STRING_NO_SIZE                           160
#define ERR_INDEX_STRING_NO_SIZE_MOD                       161
#define ERR_INDEX_OID_NO_SIZE                              162
#define ERR_INDEX_OID_NO_SIZE_MOD                          163
#define ERR_INDEX_RANGE_NEGATIVE                           164
#define ERR_INDEX_ENUM_NEGATIVE                            165
#define ERR_INDEX_NOT_COLUMN                               166
#define ERR_AUGMENT_NESTED                                 167
#define ERR_AUGMENT_NO_ROW                                 168
#define ERR_NODE_NOT_IN_GROUP                              169
#define ERR_NOTIFICATION_NOT_IN_GROUP                      170
#define ERR_INVALID_GROUP_MEMBER                           171
#define ERR_MIXED_GROUP_MEMBERS                            172
#define ERR_BAD_LOWER_IDENTIFIER_CASE                      173
#define ERR_UNDERSCORE_IN_IDENTIFIER                       174
#define ERR_OID_REUSE                                      175
#define ERR_OID_REGISTERED                                 176
#define ERR_OID_RECURSIVE                                  177
#define ERR_COMMENT_TERMINATES                             178
#define ERR_OBSOLETE_IMPORT                                179
#define ERR_GROUP_OBJECT_STATUS                            180
#define ERR_COMPLIANCE_GROUP_STATUS                        181
#define ERR_COMPLIANCE_OBJECT_STATUS                       182
#define ERR_GROUP_UNREF                                    183
#define ERR_TYPE_UNREF                                     184
#define ERR_SEQUENCE_ORDER                                 185
#define ERR_SEQUENCE_NO_COLUMN                             186
#define ERR_SEQUENCE_MISSING_COLUMN                        187
#define ERR_ILLEGAL_ROWSTATUS_DEFAULT                      188
#define ERR_ILLEGAL_ROWSTATUS_ACCESS                       189
#define ERR_ILLEGAL_STORAGETYPE_DEFAULT                    190
#define ERR_DEFVAL_OUT_OF_BASETYPE                         191
#define ERR_DEFVAL_OUT_OF_RANGE                            192
#define ERR_DEFVAL_OUT_OF_ENUM                             193
#define ERR_TADDRESS_WITHOUT_TDOMAIN                       194
#define ERR_INETADDRESS_WITHOUT_TYPE                       195
#define ERR_INETADDRESSTYPE_SUBTYPED                       196
#define ERR_INETADDRESS_SPECIFIC                           197
#define ERR_TRANSPORTADDRESS_WITHOUT_TYPE                  198
#define ERR_TRANSPORTADDRESSTYPE_SUBTYPED                  199
#define ERR_TRANSPORTADDRESS_SPECIFIC                      200
#define ERR_NOTIFICATION_OBJECT_TYPE                       201
#define ERR_NOTIFICATION_OBJECT_ACCESS                     202
#define ERR_NOTIFICATION_OBJECT_MIX                        203
#define ERR_EMPTY_DESCRIPTION                              204
#define ERR_EMPTY_REFERENCE                                205
#define ERR_EMPTY_ORGANIZATION                             206
#define ERR_EMPTY_CONTACT                                  207
#define ERR_EMPTY_FORMAT                                   208
#define ERR_EMPTY_UNITS                                    209
#define ERR_INDEX_DEFVAL                                   210
#define ERR_SEQUENCE_TYPE_MISMATCH                         211
#define ERR_INDEX_ACCESSIBLE                               212
#define ERR_INDEX_NON_ACCESSIBLE                           213
#define ERR_REFINEMENT_NOT_LISTED                          214
#define ERR_NOTIFICATION_NOT_REVERSIBLE                    215
#define ERR_NOTIFICATION_ID_TOO_LARGE                      216
#define ERR_NODE_PARENT_TYPE                               217
#define ERR_SCALAR_PARENT_TYPE                             218
#define ERR_TABLE_PARENT_TYPE                              219
#define ERR_TABLE_ROW_TYPE_MISMATCH                        220
#define ERR_ROW_PARENT_TYPE                                221
#define ERR_COLUMN_PARENT_TYPE                             222
#define ERR_NOTIFICATION_PARENT_TYPE                       223
#define ERR_GROUP_PARENT_TYPE                              224
#define ERR_COMPLIANCE_PARENT_TYPE                         225
#define ERR_CAPABILITIES_PARENT_TYPE                       226
#define ERR_SPPI_SIGNED64_NUMBER_RANGE                     227
#define ERR_SPPI_UNSIGNED64_NUMBER_RANGE                   228
#define ERR_SMI_CONSTRUCT_IN_PIB                           229
#define ERR_SMI_TYPE_IN_PIB                                230
#define ERR_SPPI_CONSTRUCT_IN_MIB                          231
#define ERR_SPPI_TYPE_IN_MIB                               232
#define ERR_POLICY_ACCESS_IN_PIB                           233
#define ERR_INVALID_SPPI_ACCESS                            234
#define ERR_INVALID_SPPI_STATUS                            235
#define ERR_SUBJECT_CATEGORIES_MISSING                     236
#define ERR_NOT_ACCESSIBLE_IN_PIB_ACCESS                   237
#define ERR_REPORT_ONLY_IN_PIB_MIN_ACCESS                  238
#define ERR_INDEX_AND_AUGMENTS_USED                        239
#define ERR_INDEX_WITHOUT_PIB_INDEX                        240
#define ERR_ERROR_NUMBER_RANGE                             241
#define ERR_SPPI_BASETYPE_NOT_IMPORTED                     242
#define ERR_ROW_LACKS_PIB_INDEX                            243
#define ERR_PIB_INDEX_FOR_NON_ROW_TYPE                     244
#define ERR_OPAQUE_IN_SYNTAX                               245
#define ERR_IPADDRESS_IN_SYNTAX                            246
#define ERR_TABLE_LACKS_PIB_ACCESS                         247
#define ERR_PIB_ACCESS_FOR_NON_TABLE                       248
#define ERR_INSTALL_ERRORS_FOR_NON_TABLE                   249
#define ERR_UNIQUENESS_FOR_NON_ROW                         250
#define ERR_NOT_A_COLUMN                                   251
#define ERR_EXTENDS_WRONG_ROW_TYPE                         252
#define ERR_PIB_INDEX_NOT_INSTANCEID                       253
#define ERR_LACKING_PIB_REFERENCES                         254
#define ERR_PIB_REFERENCES_WRONG_TYPE                      255
#define ERR_PIB_REFERENCES_NOT_ROW                         256
#define ERR_LACKING_PIB_TAG                                257
#define ERR_PIB_TAG_WRONG_TYPE                             258
#define ERR_SUBJECT_CATEGORIES_MISSING_SUBID               259
#define ERR_SUBJECT_CATEGORIES_ALL_WITH_SUBID              260
#define ERR_SUBJECT_CATEGORIES_ALL                         261
#define ERR_PIB_TAG_TYPE                                   262
#define ERR_ATTRIBUTE_NOT_IN_GROUP                         263
#define ERR_OBJECTPTR_ELEMENT_IN_USE                       264
#define ERR_OID_ADMIN_ZERO                                 265
#define ERR_TYPE_STATUS_DEPRECATED                         266
#define ERR_TYPE_STATUS_OBSOLETE                           267
#define ERR_COMPLIANCE_MEMBER_NOT_LOCAL                    268
#define ERR_MIB_MODULENAME_SUFFIX                          269
#define ERR_PIB_MODULENAME_SUFFIX                          270
#define ERR_TYPE_WITHOUT_FORMAT                            271
#define ERR_OBJECT_IN_NOTIFICATION_GROUP                   272
#define ERR_NOTIFICATION_IN_OBJECT_GROUP                   273
#define ERR_MODULE_IDENTITY_REGISTRATION                   274
